#include <stdio.h>
#include <string.h>

// Demonstration of buffer overrun. Depending on the argument given on
// the command-line, one of the following things can happen:
// - If no argument given, program crashes when strcpy is invoked with NULL
// - Short arguments, even a bit longer than 10: program terminates normally
// - Long arguments: program crashes during the return
// - In between the short and long arguments, there is a medium zone where
//   the program may crash when main() terminates. This is a bit complicated
//   to explain but essentially it happens when one manages to overwrite the
//   saved stack-base pointer but not the return address.
// Newer versions of gcc have an inbuilt mechanism to protect against some
// of these effects; to disable those, compile with -fno-stack-protector.

void foo (char *s)
{
	int i;
	char x[10];
	strcpy(x,s);
	printf("I'm about to return...\n");
}

int main (int argc, char **argv)
{
	foo(argv[1]);
	printf("I returned\n");
}
